# Environment


## Software requirements

### Yocto

_Required packages:_
- `git`
- `graphviz`
- `python2` (`python` command should call `python2` instead of `python3`)



## Yocto setup

```sh
# For YPCore - Fido
git clone -b fido git://git.yoctoproject.org/poky.git
cd poky
export POKY=$PWD

# This should be executed for each new shell:
source $POKY/oe-init-build-env
```


### Toaster

Toaster is a graphical tool to visualize build process and results.
It will launch a web server on the port 8000.

#### Setup

_Required packages:_
- `pip 2.x` (available in most distributions)
- `django 1.5`: `pip install django==1.5`
- `south`: `pip install south==0.8.4`

Toaster must be launched with __`bash`__ (`zsh` does not work)
```sh
source toaster start
```

Access the toaster interface with your web browser at [127.0.0.1:8000](127.0.0.1:8000)
