# Classes

Classes provides functions and tools that can be used in recipes.
To use a class, you must make the recipe inherit from the class.

<info data-markdown>Classes files have the `.bbclass` extension</info>


## Example: module class
See: `$POKY/meta/classes/module.bbclass`

This class provides functions to build and install kernel modules

It defines these functions
- `module_do_compile`
- `module_do_install`
- From _module-base_
	- `do_make_scripts`
- From _kernel-module-split_
	- `pkg_postinst_modules`
	- `pkg_postrm_modules`
	- `autoload_postinst_fragment`
	- `do_install_append`
	- `split_kernel_module_packages`

When writing a kernel module recipe, you have to inherit from this class using:
```sh
inherit module
```
