# Qemu


## Using `runqemu`

`runqemu` is a script provided by Yocto, that launches qemu for a specific image.

Running in qemu can be done with
```bash
MACHINE=qemux86
runqemu core-image-minimal $MACHINE ext3 qemuparams="-cpu n270"
# Note: runqemu is a script available by sourcing oe-init-build-env
#       qemuparams="-cpu n270" is needed to emulate specific CPU
#       See runqemu $MACHINE qemuparams="-cpu help"
```

<info data-markdown>
`-cpu n270` Configure the guest CPU to be Intel Atom. `-cpu help` lists available CPUs.
</info>

## Directly using qemu

### Directly booting the kernel
```sh
cd $POKY/tmp/deploy/images/$MACHINE
qemu -kernel bzImage $IMAGE-$MACHINE.ext3 -cpu n270
```

Interesting parameters:

Param|_
---|---
`-append`|Kernel command line parameters
`-hda`|Set disk image for sda device.




### Booting using target bootloader
You need to generate an image using WIC.

```sh
qemu build/*-sda.direct -cpu n270
```
