# Debugging Yocto builds

```sh
# Build $TARGET and display logs on error
bitbake $TARGET -v


# Display all environment variables, how they are
#  set and the functions for building $TARGET
bitbake -e $TARGET

# To filter informations related to a variable
bitbake -e $TARGET | grep "^VARIABLE\b" -B 20


# View packages & their dependencies:
bitbake -u depexp -g $TARGET


# Create a dependency graph for $TARGET
bitbake -g $TARGET

#Convert and open a graph file:
dot -Tsvg $FILE.dot -o /tmp/graph.svg && xdg-open /tmp/graph.svg
```
