# Creation of a distribution based on poky-tiny

_poky-tiny_ is a distribution that is packed with Yocto and is aimed to provide a very minimal OS for embeded systems.

Its is built to fit on a 8MB disk, and goes down to 1.5MB when compressed.

[More](https://wiki.yoctoproject.org/wiki/Poky-Tiny)


## Layer

The distribution must be put in a layer.

Since Yocto layers are versionned, it is better to create a new custom layer containing the distribution, and eventually additionnal softwares, machines, etc.

## Distro config

`$LAYER/conf/distro/my-distro.conf`:
```sh
# Based on poky-tiny
require conf/distro/poky-tiny.conf

DISTRO = "my-distro"
DISTRO_NAME = "my-distro"
DISTRO_VERSION = "0"

# Install dropbear SSH server
IMAGE_INSTALL_append += " dropbear"

# Dropbear has also a feature to activate:
EXTRA_IMAGE_FEATURES = "ssh-server-dropbear"

# Install syslinux:
IMAGE_INSTALL_append += " syslinux"
```